#pragma once
// You should have already added these lines.
#include "gl\gl.h"
#include "gl\glu.h"
#include <SStream>

using namespace std;

class CPointList : public CPoint
{
public:
	CPointList(CPoint const & point) : CPoint(point)
	{
		next = NULL;
	}
	CPointList() : CPoint()
	{
		next = NULL;
	}
	~CPointList()
	{
		if(next!=NULL) delete next;
	}

	CPointList* next;

};


// COpenGLControl

class COpenGLControl : public CWnd
{
	DECLARE_DYNAMIC(COpenGLControl)

public:
	COpenGLControl();
	virtual ~COpenGLControl();
	virtual void Create(CRect rect, CWnd *parent); //override
	virtual void setDrawMode(GLint mode);
	virtual void Reset()
	{
		delete pointList;
		pointList = pointListEnd = NULL;
		RedrawWindow();
	}
	virtual void toggleDrawPoints();
	virtual void toggleDrawLines();
	virtual CString getPoints();
	virtual void setPolyType(GLenum mode);
	virtual void setFrontFace(GLenum direction);
	virtual void toggleCulling();



protected:
	DECLARE_MESSAGE_MAP()
      // You will add the following stuff!!!

      virtual BOOL SetupPixelFormat( void );
      virtual BOOL SetupViewport( int cx, int cy );
      virtual BOOL SetupViewingFrustum( GLdouble aspect_ratio, int cx, int cy );
      virtual BOOL SetupViewingTransform( void );
      virtual BOOL PreRenderScene( void ) { return TRUE; }
      virtual void RenderStockScene( void );
      virtual BOOL RenderScene( void );

   private:

      BOOL InitializeOpenGL();
      void SetError( int e );
	  void drawSelectables();

      HGLRC     m_hRC;
      CDC*      m_pDC;

	  GLint drawMode;

      static const char* const _ErrorStrings[];
      const char* m_ErrorString;
      GLfloat   sceneRotate;
	  CPointList*	pointList;
	  CPointList*	pointListEnd;
	  CPointList*   activePoint;
	  bool		movePoint;
	  bool		render;
	  bool		drawPoints;
	  bool		drawLines;
	  bool		culling;
	  float		width;
	  float		height;

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
};


