// ShapesDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ShapesDemo.h"
#include "ShapesDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CShapesDemoDlg dialog




CShapesDemoDlg::CShapesDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShapesDemoDlg::IDD, pParent)
	, showPoints(_T(""))
	, PrimType(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CShapesDemoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_LIST1, showPoints);
    DDX_Control(pDX, IDC_COMBO2, m_PolyType);
    DDX_Control(pDX, IDC_COMBO3, m_FrontFace);
    DDX_Radio(pDX, IDC_RADIO7, PrimType);
}


BEGIN_MESSAGE_MAP(CShapesDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_QUIT, &CShapesDemoDlg::OnBnClickedButtonQuit)
	ON_BN_CLICKED(IDC_RADIO1, &CShapesDemoDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CShapesDemoDlg::OnBnClickedRadio2)
	ON_BN_CLICKED(IDC_RADIO3, &CShapesDemoDlg::OnBnClickedRadio3)
	ON_BN_CLICKED(IDC_RADIO4, &CShapesDemoDlg::OnBnClickedRadio4)
	ON_BN_CLICKED(IDC_RADIO5, &CShapesDemoDlg::OnBnClickedRadio5)
	ON_BN_CLICKED(IDC_RADIO6, &CShapesDemoDlg::OnBnClickedRadio6)
	ON_BN_CLICKED(IDC_RADIO10, &CShapesDemoDlg::OnBnClickedRadio10)
	ON_BN_CLICKED(IDC_RADIO7, &CShapesDemoDlg::OnBnClickedRadio7)
	ON_BN_CLICKED(IDC_RADIO8, &CShapesDemoDlg::OnBnClickedRadio8)
	ON_BN_CLICKED(IDC_RADIO9, &CShapesDemoDlg::OnBnClickedRadio9)
	ON_BN_CLICKED(IDC_BUTTON1, &CShapesDemoDlg::OnBnClickedButton1)
	ON_STN_CLICKED(ID_OPENGL_WINDOW, &CShapesDemoDlg::OnStnClickedOpenglWindow)
	ON_BN_CLICKED(IDC_CHECK1, &CShapesDemoDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK2, &CShapesDemoDlg::OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_BUTTON2, &CShapesDemoDlg::OnBnClickedButton2)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CShapesDemoDlg::OnCbnSelchangeCombo2)
	ON_CBN_SELCHANGE(IDC_COMBO3, &CShapesDemoDlg::OnCbnSelchangeCombo3)
	ON_BN_CLICKED(IDC_CHECK3, &CShapesDemoDlg::OnBnClickedCheck3)
END_MESSAGE_MAP()


// CShapesDemoDlg message handlers

BOOL CShapesDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    //Get Size and position of the template textfield we created
    //before in the dialog editor
    CRect rect;
    GetDlgItem(ID_OPENGL_WINDOW)->GetWindowRect(rect);

    //Convert screen coordinates to client coordinates
    ScreenToClient(rect);
    //Create the OpenGL window using the size and set this dialog as parent
    glArea.Create(rect,this);
    PrimType = 0;
    m_FrontFace.SetCurSel(0);
    m_PolyType.SetCurSel(0);

    UpdateData(FALSE);
    return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CShapesDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CShapesDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CShapesDemoDlg::OnBnClickedButtonQuit()
{
	// TODO: Add your control notification handler code here
	OnOK();
}


void CShapesDemoDlg::OnBnClickedRadio1()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_POINTS);
	glArea.RedrawWindow();
}

void CShapesDemoDlg::OnBnClickedRadio2()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_LINES);
	glArea.RedrawWindow();
}

void CShapesDemoDlg::OnBnClickedRadio3()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_LINE_STRIP);
	glArea.RedrawWindow();
}


void CShapesDemoDlg::OnBnClickedRadio4()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_LINE_LOOP);
	glArea.RedrawWindow();
}


void CShapesDemoDlg::OnBnClickedRadio5()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_TRIANGLES);
	glArea.RedrawWindow();
}


void CShapesDemoDlg::OnBnClickedRadio6()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_TRIANGLE_STRIP);
	glArea.RedrawWindow();
}

void CShapesDemoDlg::OnBnClickedRadio10()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_TRIANGLE_FAN);
	glArea.RedrawWindow();
}

void CShapesDemoDlg::OnBnClickedRadio7()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_QUADS);
	glArea.RedrawWindow();
}


void CShapesDemoDlg::OnBnClickedRadio8()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_QUAD_STRIP);
	glArea.RedrawWindow();
}


void CShapesDemoDlg::OnBnClickedRadio9()
{
	// TODO: Add your control notification handler code here
	glArea.setDrawMode(GL_POLYGON);
	glArea.RedrawWindow();
}

void CShapesDemoDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	glArea.Reset();
	showPoints = (CString)"";
	UpdateData(FALSE);
}

void CShapesDemoDlg::OnStnClickedOpenglWindow()
{
	// TODO: Add your control notification handler code here
}

void CShapesDemoDlg::OnBnClickedCheck1()
{
	// TODO: Add your control notification handler code here
	glArea.toggleDrawPoints();
}
void CShapesDemoDlg::OnBnClickedCheck2()
{
	// TODO: Add your control notification handler code here
	glArea.toggleDrawLines();
}


void CShapesDemoDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	showPoints = glArea.getPoints();
	UpdateData(FALSE);
}

void CShapesDemoDlg::OnEnChangeEdit3()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void CShapesDemoDlg::OnCbnSelchangeCombo2()
{
    // TODO: Add your control notification handler code here
    switch (m_PolyType.GetCurSel())
    {
    case 1:
	glArea.setPolyType(GL_POINT);
	break;
    case 2:
	glArea.setPolyType(GL_LINE);
	break;
    case 3:
	glArea.setPolyType(GL_FILL);
	break;
    }
}

void CShapesDemoDlg::OnCbnSelchangeCombo3()
{
    // TODO: Add your control notification handler code here
    switch (m_FrontFace.GetCurSel())
    {
    case 1:
	glArea.setFrontFace(GL_CW);
	break;
    case 2:
	glArea.setFrontFace(GL_CCW);
	break;
    }
}

void CShapesDemoDlg::OnBnClickedCheck3()
{
    // TODO: Add your control notification handler code here
    glArea.toggleCulling();
}
